tic
%Stock and Watson (2016)
%p=58;
%T=220;
%FRED-MD
p=128;
T=710;
%Bai (2004)
%p=60;
%T=52;
%Engel et al (2015)
%p=17;
%T=104;
%Boivin et al (2009)
%p=243;
%T=83;
N=p;
CNT=min([sqrt(p);sqrt(T)]);
U=toeplitz([1;zeros(T-1,1)],ones(1,T));
rmax=15;
for i=1:10000
    epsil=randn(p,T);
    DATA=epsil*U;
    DATA=DATA-(mean(DATA'))'*ones(1,T);
    if T<=p
        [UU,D]=eig(DATA'*DATA/(N*T));
    else
        [UU,D]=eig(DATA*DATA'/(N*T));
    end
    d=sort(real(diag(D)));
    V=flipdim(cumsum(d),1);
    pen1=V(2:(rmax+1),1)*(0:rmax)*(T/(4*log(log(T))))*((N+T)/(N*T))*log((N*T/(N+T)));
    pen2=V(2:(rmax+1),1)*(0:rmax)*(T/(4*log(log(T))))*((N+T)/(N*T))*log(CNT^2);
    pen3=V(2:(rmax+1),1)*((0:rmax).*(N+T-(0:rmax))/(N*T))*(T/(4*log(log(T))))*log(N*T);
    pen1=pen1';
    pen2=pen2';
    pen3=pen3';
    IPC1=V(1:rmax+1,1)*ones(1,rmax)+pen1;
    IPC2=V(1:rmax+1,1)*ones(1,rmax)+pen2;
    IPC3=V(1:rmax+1,1)*ones(1,rmax)+pen3;
    for j=1:rmax
        [min1,khat1]=min(IPC1(1:j+1,j));
        [min2,khat2]=min(IPC2(1:j+1,j));
        [min3,khat3]=min(IPC3(1:j+1,j));
        khat1=khat1-1;
        khat2=khat2-1;
        khat3=khat3-1;
        Kh1(i,j)=khat1;
        Kh2(i,j)=khat2;
        Kh3(i,j)=khat3;
    end
end
for i=1:rmax
    for t=0:rmax
        Tablek1(rmax+1-t,i)=sum(Kh1(:,i)==t)/100;
        Tablek2(rmax+1-t,i)=sum(Kh2(:,i)==t)/100;
        Tablek3(rmax+1-t,i)=sum(Kh3(:,i)==t)/100;
    end
end
toc